/***************************************************************************
 *   SIMBA Neuro-Workbench                                                 *
 *                                                                         *
 *   Fraunhofer Institute IAIS                                             *
 *   (Intelligent Analysis and Information Systems)                        *
 *   Sankt Augustin, Germany                                               *
 *   INDY (Intelligent Dynamics) Group                                     *
 *                                                                         *
 *   Project homepage: simba.x-bot.org                                     *
 *                                                                         *
 *   Copyright (C) 2007 by Christian Rempis                                *
 *   Contact: Christian Rempis                                             *
 *   christian.rempis@uni-osnabrueck.de                                    *
 *                                                                         *
 *                                                                         *
 *   Acknowledgments:                                                      *
 *   The SIMBA Workbench is part of the DFG Project OUTDOOR.               *
 *   This work was partially funded (2007) by DFG SPP 1125.                *
 *                                                                         *
 *                                                                         *
 *   License Agreement:                                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 *                                                                         *
 ***************************************************************************/


package de.fhg.iais.outdoor.simba.core;

import java.util.Vector;

public class PlugInManager {
	
	Vector mPlugIns = new Vector();
	
	public PlugInManager() {
		
	}
	
	/**
	 * Loads all PlugIns and installs them to the system.
	 * 
	 * @return true if all PlugIns could be loaded successfully.
	 */
	public boolean loadPlugIns() {
		boolean ok = true;
		
		loadPlugIns("./SimulatorComponents");
		
		return ok;
	}
	
	protected boolean loadPlugIns(String directory) {
		boolean ok = true;
		
		return ok;
	}
	
	/**
	 * Adds a new PlugIn to the PlugInManager. This method is used when
	 * PlugIns are loaded automatically by the PlugInManager, but it can
	 * also be used manually to install PlugIns by hand.
	 * 
	 * All PlugIns that were added before the call to installPlugIns are
	 * considered during installation.
	 * 
	 * @param plugIn the plugIn to add to the PlugInManager.
	 * @return true if successful.
	 */
	public boolean addPlugIn(PlugIn plugIn) {
		if(plugIn == null || mPlugIns.contains(plugIn)) {
			return false;
		}
		mPlugIns.add(plugIn);
		return true;
	}
	
	/**
	 * Install all previously loaded PlugIns to the system.
	 * @return true if the installation of all PlugIns was successful.
	 */
	public boolean installPlugIns() {
		boolean ok = true;
		
		return ok;
	}
	
	
	

}
