/***************************************************************************
 *   SIMBA Neuro-Workbench                                                 *
 *                                                                         *
 *   Fraunhofer Institute IAIS                                             *
 *   (Intelligent Analysis and Information Systems)                        *
 *   Sankt Augustin, Germany                                               *
 *   INDY (Intelligent Dynamics) Group                                     *
 *                                                                         *
 *   Project homepage: simba.x-bot.org                                     *
 *                                                                         *
 *   Copyright (C) 2007 by Christian Rempis                                *
 *   Contact: Christian Rempis                                             *
 *   christian.rempis@uni-osnabrueck.de                                    *
 *                                                                         *
 *                                                                         *
 *   Acknowledgments:                                                      *
 *   The SIMBA Workbench is part of the DFG Project OUTDOOR.               *
 *   This work was partially funded (2007) by DFG SPP 1125.                *
 *                                                                         *
 *                                                                         *
 *   License Agreement:                                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 *                                                                         *
 ***************************************************************************/


package de.fhg.iais.outdoor.simba.test;

import de.fhg.iais.outdoor.simba.core.Simulator;
import de.fhg.iais.outdoor.simba.fitness.FitnessFunction;
import de.fhg.iais.outdoor.simba.fitness.FitnessManager;
import junit.framework.TestCase;

public class TestFitnessManager extends TestCase {
	
	protected void tearDown() throws Exception {
		super.tearDown();
		Simulator.getInstance().clearInstance();
	}

	public void testFitnessManager() {
		FitnessManager fm = new FitnessManager();
		
		assertTrue(fm.getFitnessFunctions().isEmpty());
	
		AdapterFitnessFunction ff = new AdapterFitnessFunction("Test1");
		
		assertFalse(fm.addFitnessFunction(null));
		assertTrue(fm.addFitnessFunction(ff));
		assertEquals(fm.getFitnessFunctions().size(), 1);
		assertSame(fm.getFitnessFunctions().elementAt(0), ff);
		assertFalse(fm.addFitnessFunction(ff)); //already contained.
		assertEquals(fm.getFitnessFunctions().size(), 1);
		
		
		
	}

	public void testPrepareNextTry() {
		
	}

	public void testExecuteFitnessFunctions() {
		
	}

	public void testAddFitnessFunction() {
		
	}
	
	public class AdapterFitnessFunction extends FitnessFunction {
		
		public int mUpdateCounter;
		public double mFitnessToSet;
		
		public AdapterFitnessFunction(String name) {
			super(name);	
		}
		
		

		public void reset() {
		}

		public double calculateFitness() {
			mUpdateCounter++;
			return mFitnessToSet;
		}
		
		
	}

}
