/***************************************************************************
 *   SIMBA Neuro-Workbench                                                 *
 *                                                                         *
 *   Fraunhofer Institute IAIS                                             *
 *   (Intelligent Analysis and Information Systems)                        *
 *   Sankt Augustin, Germany                                               *
 *   INDY (Intelligent Dynamics) Group                                     *
 *                                                                         *
 *   Project homepage: simba.x-bot.org                                     *
 *                                                                         *
 *   Copyright (C) 2007 by Christian Rempis                                *
 *   Contact: Christian Rempis                                             *
 *   christian.rempis@uni-osnabrueck.de                                    *
 *                                                                         *
 *                                                                         *
 *   Acknowledgments:                                                      *
 *   The SIMBA Workbench is part of the DFG Project OUTDOOR.               *
 *   This work was partially funded (2007) by DFG SPP 1125.                *
 *                                                                         *
 *                                                                         *
 *   License Agreement:                                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 *                                                                         *
 ***************************************************************************/


package de.fhg.iais.outdoor.simba.visualization.evolution;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JPanel;

import de.fhg.iais.outdoor.simba.core.Simulator;
import de.fhg.iais.outdoor.simba.visualization.Visualization;

public class RestartGenerationButton implements Visualization {
	
	private JPanel mDisplay;
	private JCheckBox mActivateCheckbox;
	private JButton mRestartButton;
	
	public RestartGenerationButton() {
		mDisplay = new JPanel();
		
		mActivateCheckbox = new JCheckBox();
		mActivateCheckbox.setSelected(false);
		mActivateCheckbox.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if(mActivateCheckbox.isSelected()) {
					mRestartButton.setEnabled(true);
				}
				else {
					mRestartButton.setEnabled(false);
				}
			}
		});
		
		mRestartButton = new JButton("Restart Generation");
		mRestartButton.setEnabled(false);
		mRestartButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				Simulator.getInstance().getEvolutionManager().restartCurrentGeneration();
				mActivateCheckbox.setSelected(false);
				mRestartButton.setEnabled(false);
			}
		});
		
		mDisplay.add(mActivateCheckbox);
		mDisplay.add(mRestartButton);
	}

	public JPanel getPanel() {
		return mDisplay;
	}

	public boolean cleanUp() {
		return true;
	}

	public boolean init() {
		return true;
	}

}
